---
title: Update identity provider overrides for a user
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Users
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Update identity provider overrides for a user{% #update-identity-provider-overrides-for-a-user %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                                |
| ----------------- | ------------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/users/{user_id}/relationships/identity_providers |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/users/{user_id}/relationships/identity_providers |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/users/{user_id}/relationships/identity_providers      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/users/{user_id}/relationships/identity_providers      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/users/{user_id}/relationships/identity_providers  |
| uk1.datadoghq.com | PATCH https://api.uk1.datadoghq.com/api/v2/users/{user_id}/relationships/identity_providers |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/users/{user_id}/relationships/identity_providers     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/users/{user_id}/relationships/identity_providers |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/users/{user_id}/relationships/identity_providers |

### Overview

Set the identity provider overrides for a specific user in the organization. Pass an empty list to remove all overrides, reverting the user to the organization's default identity providers. This endpoint requires the `user_access_manage` permission.

OAuth apps require the `user_access_manage` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#users) to access this endpoint.



### Arguments

#### Path Parameters

| Name                      | Type   | Description         |
| ------------------------- | ------ | ------------------- |
| user_id [*required*] | string | The ID of the user. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                  | Type     | Description                                                                         |
| ------------ | ---------------------- | -------- | ----------------------------------------------------------------------------------- |
|              | data [*required*] | [object] | List of identity provider resource identifiers for a relationship update.           |
| data         | id [*required*]   | string   | The unique identifier of the identity provider.                                     |
| data         | type [*required*] | enum     | The resource type for identity providers. Allowed enum values: `identity_providers` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000001",
      "type": "identity_providers"
    }
  ]
}
```

{% /tab %}

### Response

{% tab title="204" %}
No Content
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Authentication error
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export user_id="00000000-0000-9999-0000-000000000000" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/users/${user_id}/relationships/identity_providers" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000001",
      "type": "identity_providers"
    }
  ]
}
EOF 
                
##### 

```python
"""
Update identity provider overrides for a user returns "No Content" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.users_api import UsersApi
from datadog_api_client.v2.model.update_user_identity_providers_request import UpdateUserIdentityProvidersRequest
from datadog_api_client.v2.model.user_relationship_identity_provider_data import UserRelationshipIdentityProviderData
from datadog_api_client.v2.model.user_relationship_identity_provider_data_type import (
    UserRelationshipIdentityProviderDataType,
)

body = UpdateUserIdentityProvidersRequest(
    data=[
        UserRelationshipIdentityProviderData(
            id="00000000-0000-0000-0000-000000000001",
            type=UserRelationshipIdentityProviderDataType.IDENTITY_PROVIDERS,
        ),
    ],
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = UsersApi(api_client)
    api_instance.update_user_identity_providers(user_id="00000000-0000-9999-0000-000000000000", body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update identity provider overrides for a user returns "No Content" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::UsersAPI.new

body = DatadogAPIClient::V2::UpdateUserIdentityProvidersRequest.new({
  data: [
    DatadogAPIClient::V2::UserRelationshipIdentityProviderData.new({
      id: "00000000-0000-0000-0000-000000000001",
      type: DatadogAPIClient::V2::UserRelationshipIdentityProviderDataType::IDENTITY_PROVIDERS,
    }),
  ],
})
api_instance.update_user_identity_providers("00000000-0000-9999-0000-000000000000", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update identity provider overrides for a user returns "No Content" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.UpdateUserIdentityProvidersRequest{
		Data: []datadogV2.UserRelationshipIdentityProviderData{
			{
				Id:   "00000000-0000-0000-0000-000000000001",
				Type: datadogV2.USERRELATIONSHIPIDENTITYPROVIDERDATATYPE_IDENTITY_PROVIDERS,
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewUsersApi(apiClient)
	r, err := api.UpdateUserIdentityProviders(ctx, "00000000-0000-9999-0000-000000000000", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `UsersApi.UpdateUserIdentityProviders`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update identity provider overrides for a user returns "No Content" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.UsersApi;
import com.datadog.api.client.v2.model.UpdateUserIdentityProvidersRequest;
import com.datadog.api.client.v2.model.UserRelationshipIdentityProviderData;
import com.datadog.api.client.v2.model.UserRelationshipIdentityProviderDataType;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    UsersApi apiInstance = new UsersApi(defaultClient);

    UpdateUserIdentityProvidersRequest body =
        new UpdateUserIdentityProvidersRequest()
            .data(
                Collections.singletonList(
                    new UserRelationshipIdentityProviderData()
                        .id("00000000-0000-0000-0000-000000000001")
                        .type(UserRelationshipIdentityProviderDataType.IDENTITY_PROVIDERS)));

    try {
      apiInstance.updateUserIdentityProviders("00000000-0000-9999-0000-000000000000", body);
    } catch (ApiException e) {
      System.err.println("Exception when calling UsersApi#updateUserIdentityProviders");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update identity provider overrides for a user returns "No Content" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_users::UsersAPI;
use datadog_api_client::datadogV2::model::UpdateUserIdentityProvidersRequest;
use datadog_api_client::datadogV2::model::UserRelationshipIdentityProviderData;
use datadog_api_client::datadogV2::model::UserRelationshipIdentityProviderDataType;

#[tokio::main]
async fn main() {
    let body =
        UpdateUserIdentityProvidersRequest::new(vec![UserRelationshipIdentityProviderData::new(
            "00000000-0000-0000-0000-000000000001".to_string(),
            UserRelationshipIdentityProviderDataType::IDENTITY_PROVIDERS,
        )]);
    let configuration = datadog::Configuration::new();
    let api = UsersAPI::with_config(configuration);
    let resp = api
        .update_user_identity_providers("00000000-0000-9999-0000-000000000000".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update identity provider overrides for a user returns "No Content" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.UsersApi(configuration);

const params: v2.UsersApiUpdateUserIdentityProvidersRequest = {
  body: {
    data: [
      {
        id: "00000000-0000-0000-0000-000000000001",
        type: "identity_providers",
      },
    ],
  },
  userId: "00000000-0000-9999-0000-000000000000",
};

apiInstance
  .updateUserIdentityProviders(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
